/*
  yasep/gui-js/minimize.js
  created mar. oct. 18 13:24:47 CEST 2011 by whygee@f-cpu.org
*/

JSminimize=function(src){
  var punct_string=":,-+*%(){[]<>&|=~.!",
    punct_string2=punct_string+';}\'" \t\n\r/',
    SPACE=1,WORD=2,SPACEWORD=3,STRING=4,PUNCT=5,EOF=6,ACCOLADE=7,SEMICOLON=8,
    STATE=0, // current state
    TOKEN=0, // type of the returned token;
    tok='', t, u, v, src_index=0, dst='', l=src.length;

  /////////// get a new char ///////////
  function getChar() {
    if (src_index>=l)
      return null;
    return src[src_index++];
  }

  /////////// Tokenizer ///////////
  function getToken() {
    tok='';
    t=getChar(); // get a first char

    if (t) {
      if (t==';') {
        TOKEN=SEMICOLON;
        return;
      }
      if (t=='}') {
        tok='}';
        TOKEN=ACCOLADE;
        return;
      }

      // scan for spaces
      if ((t==' ') || (t=='\r')  || (t=='\n') || (t=='\t')) {
        TOKEN=SPACE;
        do
          t=getChar();
        while ((t==' ') || (t=='\r')  || (t=='\n') || (t=='\t')); // comprises null
        src_index--; // return the unwanted char;
      }
      else {
        // scan a string
        if ((t=="'") || (t=='"')){
          TOKEN=STRING;
          tok=t;
          do {
            u=getChar();
            if (u==null)
              return alert("unfinished string");

             // escape code :
            if (u=='\\') {
              v=getChar();
              if (v==null)
                return alert("unfinished string");
              tok+=u+v; // null ???
            }
            else
              tok+=u;
          } while (t!=u);
        } else {
          if (t=='/') {
            // 3 choices : 2 comments or 1 sign, so we get the next char
            //  4th choice could be a regex... not treated here :-/
            // in the source code, use : new RegExp("myregexp","g")
            u=getChar();
            if (u=="/") {
              TOKEN=SPACE;
              // single-line comment
              do
                u=getChar();
              while ((u!='\n')&&(u != null));
            }
            else {
              if (u=="*") {
                // multi-line comment
                TOKEN=SPACE;
                do {
                  u=getChar();
                  if (u=="*"){ // need a second character to decide if we close the comment
                    u=getChar();
                    if (u=="/")
                      return
                  }
                } while (u != null);
                return alert("unfinished comment");
              }
              else {
                tok=t;
                TOKEN = PUNCT;
                src_index--; // return the unwanted char, handles u==null
              }
            }
          }
          else {
            tok=t;
            if (punct_string.indexOf(t) < 0) {
              TOKEN=WORD;
              // scan until we find a space or punctuation
              do {
                t=getChar();
                if (t==null)
                  return;
                if (punct_string2.indexOf(t) < 0)
                  tok+=t;
                // abort if a space or punctuation
                else {
                  src_index--; // return the unwanted char
                  return;
                }
              } while (true);
            }
            else
              TOKEN=PUNCT;
          }
        }
      }
    }
    else
      TOKEN = EOF;
  }

  /////////// BODY/FSM ///////////
  do {
    getToken();
    if (TOKEN == EOF)
      return dst;

    // rule 1: add a space only between 2 words
    if (TOKEN == SPACE) {
      if (STATE==WORD)
        STATE=SPACEWORD; // don't add a space yet
    }
    else {
      if ((TOKEN == WORD) && (STATE==SPACEWORD))
        dst+=' '+tok;
      else {
        // rule 2 : add a semicolon only if not followed by ";" or "}"
        if (STATE==SEMICOLON) {
          if ((TOKEN != SEMICOLON) && (TOKEN != ACCOLADE))
            dst+=';';
          // check that ALL return and string statements are correctly terminated by a semicolon
        }
        // rule 3 : add '\n' between accolade and word
        if ((STATE==ACCOLADE) && (TOKEN==WORD))
          dst+='\n';
        dst+=tok;
      }
      STATE=TOKEN;
    }
  } while (true);
}
